/*
 *  Text screen control library sample program
 */
#include <stdio.h>
#include <stdlib.h>
#include <termio.h>
#include <termcap.h>
#include <string.h>
#include <ctype.h>

/*
 * when you use libtext.a, you must include
 */
#include "tscrn.h"
/*
 * generated from sample.src by scrngen
 */
#include "sample.h"
/*
 * generated from pdmenu.src by scrngen
 */
#include "pdmenu.h"

#define FD_STDIN	0
#define FD_STDOUT	1
#define FD_STDERR	2

#define	FALSE		0
#define TRUE		!FALSE

int main(argc, argv)
    int	argc;
    char *argv[];
{
/*
 * TSCREEN structure
 */
    TSCREEN *screen, *pdmenu;

    int     col, row;
    int     ret = -1;
    
/*
 * initialize libtext
 */
    if (TInitTextLib() == -1){
	exit(1);
    }

/*
 * open main screen(screen.scrn)
 */
    if ((screen = TOpenScreen("sample")) == (TSCREEN *)NULL){
	exit(1);
    }

/*
 * set cursor when up/down cursor is pushed
 */
    TSetNextItem(screen, sample_input1, sample_input3);
    TSetNextItem(screen, sample_input2, sample_input4);
    TSetPrevItem(screen, sample_input3, sample_input1);
    TSetPrevItem(screen, sample_input4, sample_input2);

/*
 * open pulldown menu(pdmenu.scrn)
 */
    if ((pdmenu = TOpenScreen("pdmenu")) == (TSCREEN *)NULL){
	exit(1);
    }
    
/*
 * set cursor position
 */
    TSetCurrentCursor(screen, sample_sel1);
	
/*
 * input/output main screen
 */
    ret = TIOScreen(screen);

/*
 * loop till 'END'(sample_sel2) will be selected
 */
    while (TGetSelectedItem(screen) != sample_sel2){
	
/*
 * set main screen input key to output item
 */
	switch (ret){
	  case T_PU:
	    TSetItem(screen, sample_out6, "PageUp");
	    break;
	  case T_PD:
	    TSetItem(screen, sample_out6, "PageDown");
	    break;
	  case T_ENT:
	    TSetItem(screen, sample_out6, "Enter");
	    break;
	  case T_F01:
	    TSetItem(screen, sample_out6, "PF01");
	    break;
	  case T_F02:
	    TSetItem(screen, sample_out6, "PF02");
	    break;
	  case T_F03:
	    TSetItem(screen, sample_out6, "PF03");
	    break;
	  case T_F04:
	    TSetItem(screen, sample_out6, "PF04");
	    break;
	  case T_F05:
	    TSetItem(screen, sample_out6, "PF05");
	    break;
	  case T_F06:
	    TSetItem(screen, sample_out6, "PF06");
	    break;
	  case T_F07:
	    TSetItem(screen, sample_out6, "PF07");
	    break;
	  case T_F08:
	    TSetItem(screen, sample_out6, "PF08");
	    break;
	  case T_F09:
	    TSetItem(screen, sample_out6, "PF09");
	    break;
	  case T_F10:
	    TSetItem(screen, sample_out6, "PF10");
	    break;
	  case T_F11:
	    TSetItem(screen, sample_out6, "PF11");
	    break;
	  case T_F12:
	    TSetItem(screen, sample_out6, "PF12");
	    break;
	  default:
	    TSetItem(screen, sample_out6, "????");
	    break;
	}

/*
 * is pulldown selected ?
 */
	if (TGetSelectedItem(screen) == sample_sel1){

/*
 * get position of pulldown
 */
	    TGetItemPosition(screen, TGetSelectedItem(screen), &col, &row);

/*
 * set pulldown position
 */
	    TSetScreenPosition(pdmenu, col, row+1);

/*
 * input/output pulldown
 */
	    TIOScreen(pdmenu);

/*
 * set selected item on pulldown to output item
 */
	    switch (TGetSelectedItem(pdmenu)){
	      case pdmenu_sel1:
		TSetItem(screen, sample_out1, "SELECT   1");
		break;
	      case pdmenu_sel2:
		TSetItem(screen, sample_out1, "SELECT   2");
		break;
	      case pdmenu_sel3:
		TSetItem(screen, sample_out1, "SELECT   3");
		break;
	      case pdmenu_sel4:
		TSetItem(screen, sample_out1, "SELECT   4");
		break;
	      case pdmenu_sel5:
		TSetItem(screen, sample_out1, "SELECT   5");
		break;
	      default:
		TSetItem(screen, sample_out1, "??????????");
		break;
	    }
	}

/*
 * set input item from main screen to output item
 */
	TSetItem(screen, sample_out2, TGetItem(screen, sample_input1));
	TSetItem(screen, sample_out3, TGetItem(screen, sample_input2));
	TSetItem(screen, sample_out4, TGetItem(screen, sample_input3));
	TSetItem(screen, sample_out5, TGetItem(screen, sample_input4));

/*
 * input/output main screen
 */
	ret = TIOScreen(screen);
    }

/*
 * free screen structure
 */
    TCloseScreen(screen);
    TCloseScreen(pdmenu);

/*
 * clear all
 */
    TClear();

    exit(0);
}

